/* cnw6502.h */

#ifndef CNW6502_H
#define CNW6502_H

/* Zero-page locations */
#define TI_TICK (*(unsigned char*)0x36)
#define TI_SEC (*(unsigned char*)0x37)
#define TI_MIN (*(unsigned char*)0x38)
#define TI_HOUR (*(unsigned char*)0x39)
#define TI_DAY (*(unsigned char*)0x3A)
#define TI_DATE (*(unsigned char*)0x3B)
#define TI_MON (*(unsigned char*)0x3C)
#define TI_YEAR (*(unsigned char*)0x3D)
#define TI_CENT (*(unsigned char*)0x3E)

#define IDEBUFP (*(unsigned int*)0x3F)
#define IDELBA (*(unsigned long*)0x43)
#define IDESIZE (*(unsigned long*)0x48)
#define IDESPC (*(unsigned int*)0x4C)
#define IDESPT (*(unsigned char*)0x4E)

#define DRIVES ((unsigned char*)0x4F)
#define DRIVE (*(unsigned char*)0x57)
#define FILENAME (*(unsigned int*)0x58)
#define FILE (*(unsigned char*)0x5A)

/* BIOS jump table */
#define LCDCLR 0xFF00
#define LCDCHAR 0xFF03
#define LCDHEX 0xFF06
#define LCDHEX1 0xFF09
#define LCDSTR 0xFF0C
#define LCDSTRN 0xFF0F
#define LCDGETXY 0xFF12
#define LCDSETXY 0xFF15
#define KEYSCAN 0xFF18
#define WAITKEY 0xFF1B
#define GETKEY 0xFF1E
#define GETNUM 0xFF21
#define GETHEX 0xFF24
#define TXBYTE 0xFF27
#define RXBYTE 0xFF2A
#define IDERSEC 0xFF2D
#define IDEWSEC 0xFF30

#include <_6522.h>
#define VIA1    (*(struct __6522*)0xD100)
#define VIA2    (*(struct __6522*)0xD200)

/* Character codes */
#define CH_ULCORNER     '+'
#define CH_URCORNER     '+'
#define CH_LLCORNER     '+'
#define CH_LRCORNER     '+'
#define CH_TTEE         '+'
#define CH_BTEE         '+'
#define CH_LTEE         '+'
#define CH_RTEE         '+'
#define CH_CROSS        '+'

/* Useful macros */
#define hibyte(x) (__AX__=(x),asm("\ttxa\n\tldx\t#$00"),__AX__)
//#define hibyte(x) (x >> 8)
#define lobyte(x) (__AX__=(x),asm("\tldx\t#$00"),__AX__)
//#define lobyte(x) (x & 0xFF)
#define hiword(x) (x >> 16)
#define loword(x) (x & 0xFFFF)

#endif
