;
; Startup code for cc65
;
; This must be the *first* file on the linker command line
;

	.export		_exit
       	.import		initlib, donelib
          .import    	callmain, callirq
       	.import		zerobss, push0
	.import		_main

	.include "zeropage.inc"
	.include "cnw6502.inc"

.segment       	"STARTUP"

; ------------------------------------------------------------------------
; Actual code

; Clear the BSS data

	jsr	zerobss

; Save system stuff and setup the stack

       	tsx
       	stx    	spsave 		; Save the system stack ptr

	lda    	#<TOPMEM
	sta	sp
	lda	#>TOPMEM
       	sta	sp+1   	 	; Set argument stack ptr

; Call module contructors

	jsr	initlib

; Push arguments and call main

	jsr	callmain

; Call module destructors. This is also the _exit entry.

_exit:	jsr	donelib

	ldx	spsave
	txs	 	 	; Restore stack pointer

       	rts


.bss

spsave:	.res	1
